# keyboard_config_t Struct Reference

`#include <keyboard.h>`

## Data Fields
u16 | midi_ports
u8 | midi_chn
u8 | note_offset
u8 | num_rows
u8 | selected_row
u8 | prev_row
u8 | verbose_level
u8 | dout_sr1
u8 | dout_sr2
u8 | din_sr1
u8 | din_sr2
u8 | din_key_offset
u8 | din_inverted:1
u8 | break_inverted:1
u8 | scan_velocity:1
u8 | scan_optimized:1
u8 | scan_release_velocity:1
u8 | make_debounced:1
u8 | break_is_make:1
u8 | key_calibration:1
u16 | delay_fastest
u16 | delay_fastest_black_keys
u16 | delay_fastest_release
u16 | delay_fastest_release_black_keys
u16 | delay_slowest
u16 | delay_slowest_release
u16 | delay_key [KEYBOARD_MAX_KEYS]
u32 | ain_timestamp [KEYBOARD_AIN_NUM]
u8 | ain_pin [KEYBOARD_AIN_NUM]
u8 | ain_ctrl [KEYBOARD_AIN_NUM]
u8 | ain_min [KEYBOARD_AIN_NUM]
u8 | ain_max [KEYBOARD_AIN_NUM]
u8 | ain_last_value7 [KEYBOARD_AIN_NUM]
u8 | ain_inverted [KEYBOARD_AIN_NUM]
u8 | ain_sustain_switch
u8 | ain_bandwidth_ms

## Field Documentation

u8 keyboard_config_t::ain_bandwidth_ms

u8 keyboard_config_t::ain_ctrl[KEYBOARD_AIN_NUM]

u8 keyboard_config_t::ain_inverted[KEYBOARD_AIN_NUM]

u8 keyboard_config_t::ain_last_value7[KEYBOARD_AIN_NUM]

u8 keyboard_config_t::ain_max[KEYBOARD_AIN_NUM]

u8 keyboard_config_t::ain_min[KEYBOARD_AIN_NUM]

u8 keyboard_config_t::ain_pin[KEYBOARD_AIN_NUM]

u8 keyboard_config_t::ain_sustain_switch

u32 keyboard_config_t::ain_timestamp[KEYBOARD_AIN_NUM]

u8 keyboard_config_t::break_inverted

u8 keyboard_config_t::break_is_make

u16 keyboard_config_t::delay_fastest

u16 keyboard_config_t::delay_fastest_black_keys

u16 keyboard_config_t::delay_fastest_release

u16 keyboard_config_t::delay_fastest_release_black_keys

u16 keyboard_config_t::delay_key[KEYBOARD_MAX_KEYS]

u16 keyboard_config_t::delay_slowest

u16 keyboard_config_t::delay_slowest_release

u8 keyboard_config_t::din_inverted

u8 keyboard_config_t::din_key_offset

u8 keyboard_config_t::din_sr1

u8 keyboard_config_t::din_sr2

u8 keyboard_config_t::dout_sr1

u8 keyboard_config_t::dout_sr2

u8 keyboard_config_t::key_calibration

u8 keyboard_config_t::make_debounced

u8 keyboard_config_t::midi_chn

u16 keyboard_config_t::midi_ports

u8 keyboard_config_t::note_offset

u8 keyboard_config_t::num_rows

u8 keyboard_config_t::prev_row

u8 keyboard_config_t::scan_optimized

u8 keyboard_config_t::scan_release_velocity

u8 keyboard_config_t::scan_velocity

u8 keyboard_config_t::selected_row

u8 keyboard_config_t::verbose_level

The documentation for this struct was generated from the following file:

- modules/keyboard/keyboard.h